DROP VIEW user_perm_snapshot_v;

CREATE VIEW user_perm_snapshot_v AS 
 SELECT DISTINCT appl.qid AS appl_qid,
    ds.name AS appl_name,
    perm.unique_permission_id AS perm_qid,
    perm.name AS perm_name,
    perm.type,
    usr.unique_user_id AS user_qid,
    usr.dn AS user_dn,
    usr.last_name AS user_last_name,
    usr.first_name AS user_first_name,
    usr.idm_tree_name AS user_idm_tree_name,
    snap.id AS snap_id,
    snap."timestamp" AS snap_timestamp
   FROM spermission perm
     LEFT JOIN application appl ON perm.application = appl.id
     LEFT JOIN spermission pcoll ON perm.collected_entity = pcoll.id
     LEFT JOIN saccount_permission ap ON pcoll.id = ap.spermission
     LEFT JOIN saccount acoll ON ap.saccount = acoll.id
     LEFT JOIN saccount_user au ON acoll.id = au.saccount
     LEFT JOIN saccount acct ON acoll.id = acct.collected_entity
     LEFT JOIN suser ucoll ON au.suser = ucoll.id
     LEFT JOIN suser usr ON ucoll.id = usr.collected_entity
     LEFT JOIN data_source ds ON appl.id = ds.id
     LEFT JOIN snapshot_sversions ap_snap_sv ON ap.sversion = ap_snap_sv.sversions
     LEFT JOIN snapshot_sversions au_snap_sv ON au.sversion = au_snap_sv.sversions
     JOIN snapshot snap ON ap_snap_sv.snapshot = snap.id AND au_snap_sv.snapshot = snap.id;

ALTER TABLE public.user_perm_snapshot_v
  OWNER TO igops;
GRANT ALL ON TABLE public.user_perm_snapshot_v TO igops;
GRANT SELECT ON TABLE public.user_perm_snapshot_v TO ig_report_role;